roof
	var
		turf/lower_left_loc
		size_x
		size_y
		list
			tiles = list()
			viewers = list()
	proc
		show(client/C)
			if(!src.viewers.Find(C.ckey))
				display(C)
		refresh(client/C)
			if(src.viewers.Find(C.ckey)) hide(C)
			display(C)
		display(client/C)
			var/list/added_images = new
			for(var/i=0,i<=(size_x-1),++i)
				for(var/j=0,j<=(size_y-1),++j)
					var/turf/image_loc = locate(lower_left_loc.x+i,lower_left_loc.y+j,lower_left_loc.z)
					var/atom/my_tile = tiles["[i],[j]"]
					var/my_tile_image = image(my_tile.icon,image_loc,my_tile.icon_state,FLY_LAYER)
					added_images.Add(my_tile_image)
					C << my_tile_image
			viewers[C.ckey] = added_images
		hide(client/C)
			ASSERT(src.viewers.Find(C.ckey))
			var/images_to_remove = viewers[C.ckey]
			for(var/i in images_to_remove) del i
			src.viewers.Remove(C.ckey)
proc/create_roof(turf/lower_left_location,roof_type,new_size_x,new_size_y)
	ASSERT(new_size_x>1&&new_size_y>1)
	var/roof/new_roof = new
	new_roof.size_x = new_size_x
	new_roof.size_y = new_size_y
	new_size_x--
	new_size_y--
	for(var/i=0,i<=new_size_x,++i)
		for(var/j=0,j<=new_size_y,++j)
			var/new_tile
			if(i==0)
				if(j==0) new_tile = text2path("[roof_type]/lower_left")
				else if(j==new_size_y) new_tile = text2path("[roof_type]/upper_left")
				else new_tile = text2path("[roof_type]/left_side")
			else if(i==new_size_x)
				if(j==0) new_tile = text2path("[roof_type]/lower_right")
				else if(j==new_size_y) new_tile = text2path("[roof_type]/upper_right")
				else new_tile = text2path("[roof_type]/right_side")
			else
				if(j==0) new_tile = text2path("[roof_type]/bottom_side")
				else if(j==new_size_y) new_tile = text2path("[roof_type]/top_side")
				else new_tile = text2path("[roof_type]/middle")
			new_roof.tiles["[i],[j]"] = new new_tile
	new_roof.lower_left_loc = lower_left_location
	return new_roof